use DB2CLI;

SQLAllocEnv($henv)				and message("AllocEnv");
SQLAllocConnect($henv, $hdbc)			and message("AllocConnect");
SQLConnect($hdbc, 'SAMPLE', 'AK', '')		and message("Connect");
SQLAllocStmt($hdbc, $hstmt)			and message("AllocStmt");

SQLPrepare($hstmt, <<)				and message("Prepare");
    SELECT name,salary FROM ADMIN.STAFF

SQLExecute($hstmt, 20000)			and message("Execute");

SQLNumResultCols($hstmt, $ncol)			and message("NumResultsCol");
while (($r = SQLFetch($hstmt)) == 0) {
    SQLGetData($hstmt, 1, SQL_C_CHAR, $name)	and message("GetData 1");
    SQLGetData($hstmt, 2, SQL_C_BINARY, $sal)	and message("GetData 2");
    $len = length($sal);
    printf "name='$name',sal2=$sal2, length(sal)=$len, data=%08lX\n", unpack("L", $sal);
    
}
message("Fetch", $r) if $r != SQL_NO_DATA_FOUND();

SQLFreeStmt($hstmt)				and message("FreeStmt");
SQLDisconnect($hdbc)				and message("Disconnect");
SQLFreeConnect($hdbc)				and message("FreeConnect");
SQLFreeEnv($henv)				and message("FreeEnv");

exit 0;

sub message
{
    my ($where, $retcode) = @_;
    my ($state, $native, $text);
    if (SQLError($henv, $hdbc, $hstmt, $state, $native, $text) >= 0) {
	print "$where: $state,$native: $text\n";
	exit 1;
    }
    print "$where: cannot retrieve error info, retcode=$retcode\n";
    exit 2;
}
