use DB2CLI;

SQLAllocEnv($henv)				and message("AllocEnv");
SQLAllocConnect($henv, $hdbc)			and message("AllocConnect");
SQLConnect($hdbc, 'SAMPLE', 'AK', '')		and message("Connect");
SQLAllocStmt($hdbc, $hstmt)			and message("AllocStmt");

SQLExecDirect($hstmt, <<, 20000)		and message("ExecDirect");
	SELECT name,salary FROM ADMIN.STAFF
        WHERE salary >= ?

while (($r = SQLFetch($hstmt, $name, $sal)) == 0) {
    print "$name,$sal\n";
}
message("Fetch", $r) if $r != SQL_NO_DATA_FOUND();

SQLFreeStmt($hstmt)				and message("FreeStmt");
SQLDisconnect($hdbc)				and message("Disconnect");
SQLFreeConnect($hdbc)				and message("FreeConnect");
SQLFreeEnv($henv)				and message("FreeEnv");

exit 0;

sub message
{
    my ($where, $retcode) = @_;
    my ($state, $native, $text);
    if (SQLError($henv, $hdbc, $hstmt, $state, $native, $text) >= 0) {
	print "$where: $state,$native: $text\n";
	exit 1;
    }
    print "$where: cannot retrieve error info, retcode=$retcode\n";
    exit 2;
}
